
;******************************** 128 MODE ROUTINES *******************************

STORER_:		LDI		ZH,0XC0				; 1
				LDI		ZL,0X00				; 1 EXTERNAL RAM
				LDI		BUF,(1<<MUXA16)		; 1 ADDRESS 0X10000
				OUT		PORTB,BUF			; 1 
				LDI		TMPH,1<<A16			; 2
				IN		BUF,PIND			; 2 INVERSE A16
				EOR		BUF,TMPH			; 2 
				OUT		PORTD,BUF			; 2 		
				IN		BUF,I				; 
				MOV		TMPH,IXH			; 
				MOV		TMPL,IXL			; 
				XON_RBBCP					; ON XMEM
				ST		Z+,PCL				; 
				ST		Z+,PCH				; 
				ST		Z+,C				; 
				ST		Z+,B				; 
				ST		Z+,E				; 
				ST		Z+,D				; 
				ST		Z+,L				; 
				ST		Z+,H				; 
				ST		Z+,F				; 
				ST		Z+,RES				;
				ST		Z+,A				; 
				ST		Z+,BUF				; 
				ST		Z+,R				; 
				ST		Z+,TMPL				;
				ST		Z+,TMPH				;
				MOV		TMPH,IYH			; 
				MOV		TMPL,IYL			; 	
				ST		Z+,STPL				; 
				ST		Z+,STPH				; 
				ST		Z+,_C				; 
				ST		Z+,_B				; 
				IN		BUF,_E				;
				ST		Z+,BUF				; 
				IN		BUF,_D				;
				ST		Z+,BUF				; 
				IN		BUF,_L				;
				ST		Z+,BUF				; 
				IN		BUF,_H				;
				ST		Z+,BUF				; 
				IN		BUF,_F				;
				ST		Z+,BUF				; 
				IN		BUF,_RES			; 
				ST		Z+,BUF				; 
				IN		BUF,_A				;
				ST		Z+,BUF				; 
				ST		Z+,TMPL				; 
				ST		Z+,TMPH				; 
				MOV		TMPH,MEMPTRH		; 
				MOV		TMPL,MEMPTRL		; 
				ST		Z+,TMPL				; 
				ST		Z+,TMPH				; 
				IN		BUF,CONTROL			; 
				ST		Z+,BUF				; 
				IN		BUF,ACSR			; 
				ST		Z+,BUF				; 
				IN		BUF,PINB			; 
				ST		Z+,BUF				; 
				IN		BUF,PIND			; 
				ST		Z,BUF				; 
				LDI		ZL,0XFF				; 
				LDI		BUF,128				; 
				ST		Z,BUF				; STORE MODE MARKER
				NOP							; OFF
				XOFF_RBBCP					; XMEM
				LDI		BUF,(1<<MUXA15)|(1<<MUXA14)	; 1 NORMAL POTRB (RAM MUX)
				OUT		PORTB,BUF					; 1 CONFIGURATION
				LDI		TMPH,1<<A16			; 2
				IN		BUF,PIND			; 2 INVERSE A16
				EOR		BUF,TMPH			; 2 
				OUT		PORTD,BUF			; 2 
				CBI		PORTD,TOVCPU		; GENERANE VIDEOCPU REQUEST
WFA1:			SBIC	PIND,TOCPU			; WAIT FOR ANSWER
				RJMP	WFA1				; 
				SBI		PORTD,TOVCPU		; CLEAR REQUEST
WFA2:			SBIS	PIND,TOCPU			; WAIT FOR 
				RJMP	WFA2				; OPERATION COMPLETE
M11:			JMP		M1					; RETURN TO M1


LOADER_:		LDI		BUF,(1<<MUXA16)		; 1 ADDRESS 0X10000
				OUT		PORTB,BUF			; 1 
				LDI		TMPH,1<<A16			; 2
				IN		BUF,PIND			; 2 INVERSE A16
				EOR		BUF,TMPH			; 2 
				OUT		PORTD,BUF			; 2 
				LDI		ZH,0XC0				; 1 LOADER MARKER
				LDI		ZL,0XFF				; 1 ADDRESS
				LDI		BUF,0X02			; 
				XON_RBBCP					; ENABLE XMEM
				ST		Z,BUF			; LOADER MARKER = 2
				XOFF_RBBCP					; DISABLE XMEM
				CBI		PORTD,TOVCPU		; GENERANE VIDEOCPU REQUEST
WFVCPUANS3:		SBIC	PIND,TOCPU			; WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS3			; ANSWER
				SBI		PORTD,TOVCPU		; OFF VIDEOCPU REQUEST
WFVCPUANS4:		SBIS	PIND,TOCPU			; WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS4			; LOAD OPERATION COMPLETE
				LDI		ZL,0X00				; ADDRESS OF DATA BEGIN
				XON_RBBCP					; ON XMEM
				LD		PCL,Z+				; 
				LD		PCH,Z+				; 
				LD		C,Z+				; 
				LD		B,Z+				; 
				LD		E,Z+				; 
				LD		D,Z+				; 
				LD		L,Z+				; 
				LD		H,Z+				;
				LD		F,Z+				; 
				LD		RES,Z+				; 
				LD		A,Z+				; 
				LD		BUF,Z+				; 
				OUT		I,BUF				; 
				LD		R,Z+				; 
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				MOV		IXH,TMPH			; 
				MOV		IXL,TMPL			; 	
				LD		STPL,Z+				; 
				LD		STPH,Z+				; 
				LD		_C,Z+				; 
				LD		_B,Z+				; 
				LD		BUF,Z+				; 
				OUT		_E,BUF				;
				LD		BUF,Z+				; 
				OUT		_D,BUF				;
				LD		BUF,Z+				; 
				OUT		_L,BUF				;
				LD		BUF,Z+				; 
				OUT		_H,BUF				;
				LD		BUF,Z+				; 
				OUT		_F,BUF				;
				LD		BUF,Z+				; 
				OUT		_RES,BUF			; 
				LD		BUF,Z+				; 
				OUT		_A,BUF				;
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				MOV		IYL,TMPL			; 
				MOV		IYH,TMPH			; 
				LD		TMPL,Z+				; 
				LD		TMPH,Z+				; 
				MOV		MEMPTRL,TMPL		; 
				MOV		MEMPTRH,TMPH		; 
				LD		BUF,Z+				; 
				OUT		CONTROL,BUF			; 
				LD		BUF,Z+				; 
				OUT		ACSR,BUF			; 
				LD		BUF,Z+				; 
				OUT		PORTB,BUF			; 
				LD		BUF,Z				; 
				OUT		PORTD,BUF			; 
				NOP							; OFF
				XOFF_RBBCP					; XMEM
				LDI		BUF,(1<<MUXA15)|(1<<MUXA14)	; 1 NORMAL POTRB (RAM MUX)
				OUT		PORTB,BUF					; 1 CONFIGURATION
				LDI		TMPH,1<<A16			; 2
				IN		BUF,PIND			; 2 INVERSE A16
				EOR		BUF,TMPH			; 2 
				OUT		PORTD,BUF			; 2 
				SBI		ACSR,ACI			; RESET AC FLAG 
				RJMP	M1


DISASM_TABLE:	SBI		PORTD,A16				; ^ 1 SET A16               ^^^^^^^^ LOADING DISASM TABLE ^^^^^^^^
				CBI		PORTC,7					; ^ 1 RESET 
				SBI		DDRC,7					; ^ 1 A15
				LDI		BUF,1<<XMM0				; ^ 1 RELEASE
				STS		XMCRB,BUF				; ^ 1 PC7
				LDI		ZH,0X80					; ^ 1 LOADER MARKER
				LDI		ZL,0XFF					; ^ 1 ADDRESS
				LDI		BUF,0X02				; ^
				XON_RBBCP						; ^ ENABLE XMEM
				ST		Z,BUF					; ^ LOADER MARKER = 2
				XOFF_RBBCP						; ^ DISABLE XMEM
				CBI		DDRC,7					; ^ A15 AS INPUT
				CBI		PORTD,TOVCPU			; ^ GENERANE VIDEOCPU REQUEST
WFVCPUANS5:		SBIC	PIND,TOCPU				; ^ WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS5				; ^ ANSWER
				SBI		PORTD,TOVCPU			; ^ OFF VIDEOCPU REQUEST
WFVCPUANS6:		SBIS	PIND,TOCPU				; ^ WAIT WOR VIDEOCPU
				RJMP	WFVCPUANS6				; ^ LOAD OPERATION COMPLETE
				STS		XMCRB,ZERO				; ^ 2 PC7 AS A15
				CBI		PORTD,A16				; ^ 1 RESET A16
				RET								; RETURN TO MAIN PROGRAMM








