;***************************** MACRO DEFINITIONS ***************************************

.MACRO M1H_INTTST[4]
SBIC	PINF,INTFLG
CALL	SNDSTR	
		SBIC	ACSR,ACI				; 1
		SEI								; 2
		INC		R						; 3
		CPI		XH,0X40					; 4
.ENDMACRO

.MACRO M1H_INTEN[3]
SBIC	PINF,INTFLG
CALL	SNDSTR
SBIC	ACSR,ACI
		SEI								; 1
		INC		R						; 2
		CPI		XH,0X40					; 3
.ENDMACRO

.MACRO M1H_INTEN_SHORT[2]
SBIC	PINF,INTFLG
CALL	SNDSTR
SBIC	ACSR,ACI
		SEI								; 1
		INC		R						; 2
.ENDMACRO

.MACRO M1H[2]
SBIC	PINF,INTFLG
CALL	SNDSTR
SBIC	ACSR,ACI
SEI
		INC		R						; 1
		CPI		XH,0X40					; 2
.ENDMACRO

.MACRO M1H_SHORT[1]
SBIC	PINF,INTFLG
CALL	SNDSTR
SBIC	ACSR,ACI
SEI
		INC		R						; 1
.ENDMACRO

.MACRO M1L_RAM[12]
		XON_RBBCP						; 2
		LD		ZH,X+					; 5
		XOFF_RBBCP						; 7
		LDI		ZL,0X00					; 8
		LSR		ZH						; 9
		ROR		ZL						; 10
		IJMP							; 12
.ENDMACRO

.MACRO	M1L_RAM_[12]
		;ADIW	ZL,0X00					; 2
		;ADIW	ZL,0X00					; 4
		ADIW	PCL,0X01				; 6
		MOV		ZH,BUF					; 7
		LDI		ZL,0X00					; 8
		LSR		ZH						; 9
		ROR		ZL						; 10
		IJMP							; 12
.ENDMACRO

.MACRO	M1L_RAM__SHORT[9]
		;ADIW	PCL,0X01				; 2
		;NOP								; 3
		MOV		ZH,BUF					; 4
		LDI		ZL,0X00					; 5
		LSR		ZH						; 6
		ROR		ZL						; 7
		IJMP							; 9
.ENDMACRO

.MACRO M1L_ROM[13]
		MOVW	ZL,PCL					; 1
		OR		ZH,ROMID				; 2
		ELPM	ZH,Z					; 5
		ADIW	PCL,0X01				; 7
		LDI		ZL,0X01					; 8
		LSR		ZH						; 9
		ROR		ZL						; 10
		;NOP								; 11
		IJMP							; 13
.ENDMACRO

.MACRO M1L_ROM_SHORT[12]
		MOVW	ZL,PCL					; 1
		OR		ZH,ROMID				; 2
		ELPM	ZH,Z					; 5
		ADIW	PCL,0X01				; 7
		LDI		ZL,0X01					; 8
		LSR		ZH						; 9
		ROR		ZL						; 10
		IJMP							; 12
.ENDMACRO

;*********************************************************************************
;*********************************************************************************
;*********************************************************************************

.MACRO XOFF
		OUT		MCUCR,ZERO
.ENDMACRO

.MACRO XON_RBBCP
		OUT		PORTE,ZERO
		OUT		MCUCR,CONST128
.ENDMACRO

.MACRO XOFF_RBBCP
		OUT		MCUCR,ZERO
		OUT		PORTE,CONST128
.ENDMACRO

;*********************************************************************************
;*********************************************************************************
;*********************************************************************************


.MACRO LOAD_BUF_PC[7]
		XON_RBBCP
		LD		BUF,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_TMPL_PC_[10]
		XON_RBBCP
		LD		TMPL,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_RES_PC[7]
		XON_RBBCP
		LD		RES,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_RES_PC_[10]
		XON_RBBCP
		LD		RES,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_B_PC[7]
		XON_RBBCP
		LD		B,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_B_PC_[10]
		XON_RBBCP
		LD		B,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_C_PC[7]
		XON_RBBCP
		LD		C,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_C_PC_[10]
		XON_RBBCP
		LD		C,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_D_PC[7]
		XON_RBBCP
		LD		D,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_D_PC_[10]
		XON_RBBCP
		LD		D,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_E_PC[7]
		XON_RBBCP
		LD		E,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_E_PC_[10]
		XON_RBBCP
		LD		E,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_PC[7]
		XON_RBBCP
		LD		A,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_PC_[10]
		XON_RBBCP
		LD		A,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_H_PC_[10]
		XON_RBBCP
		LD		H,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_L_PC_[10]
		XON_RBBCP
		LD		L,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IXH_PC_[10]
		XON_RBBCP
		LD		IXH,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IXL_PC_[10]
		XON_RBBCP
		LD		IXL,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO


.MACRO LOAD_ZH_PC[7]
		XON_RBBCP
		LD		ZH,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BC_PC[10]
		XON_RBBCP
		LD		C,X+
		LD		B,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BC_PC_[13]
		XON_RBBCP
		LD		C,X+
		LD		B,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_DE_PC[10]
		XON_RBBCP
		LD		E,X+
		LD		D,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_DE_PC_[13]
		XON_RBBCP
		LD		E,X+
		LD		D,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_HL_PC_[13]
		XON_RBBCP
		LD		L,X+
		LD		H,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IX_PC_[13]
		XON_RBBCP
		LD		IXL,X+
		LD		IXH,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_PC_STP[10]
		XON_RBBCP
		LD		PCL,Y+
		LD		PCH,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_PC_STP_[13]
		XON_RBBCP
		LD		PCL,Y+
		LD		PCH,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BC_STP[10]
		XON_RBBCP
		LD		C,Y+
		LD		B,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BC_STP_[13]
		XON_RBBCP
		LD		C,Y+
		LD		B,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_DE_STP[10]
		XON_RBBCP
		LD		E,Y+
		LD		D,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_DE_STP_[13]
		XON_RBBCP
		LD		E,Y+
		LD		D,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_HL_STP[10]
		XON_RBBCP
		LD		L,Y+
		LD		H,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_HL_STP_[13]
		XON_RBBCP
		LD		L,Y+
		LD		H,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_AF_STP[9]
		XON_RBBCP
		LD		F,Y+
		LD		A,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_AF_STP_[13]
		XON_RBBCP
		LD		F,Y+
		LD		A,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_Z_STP[11]
		XON_RBBCP
		LD		ZL,Y+
		LD		ZH,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IX_STP[10]
		XON_RBBCP
		LD		IXL,Y+
		LD		IXH,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IX_STP_[13]
		XON_RBBCP
		LD		IXL,Y+
		LD		IXH,Y+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IY_STP[10]
		XON_RBBCP
		LD		IYL,Y+
		LD		IYH,Y+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IYH_PC_[10]
		XON_RBBCP
		LD		IYH,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IYL_PC_[10]
		XON_RBBCP
		LD		IYL,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

;****************************************************************************************
;****************************************************************************************


.MACRO LOAD_BUF_Z[7]
		XON_RBBCP
		LD		BUF,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BUFH_Z[7]
		XON_RBBCP
		LD		BUFH,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BUFH_Z_[10]
		XON_RBBCP
		LD		BUFH,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_RES_Z[7]
		XON_RBBCP
		LD		RES,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_TMPL_Z[7]
		XON_RBBCP
		LD	TMPL,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_TMPL_ZI[7]
		XON_RBBCP
		LD	TMPL,Z+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_Z[7]
		XON_RBBCP
		LD		A,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_Z_[10]
		XON_RBBCP
		LD		A,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_ZI[7]
		XON_RBBCP
		LD		A,Z+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_A_ZI_[10]
		XON_RBBCP
		LD		A,Z+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_B_Z[7]
		XON_RBBCP
		LD		B,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_B_Z_[10]
		XON_RBBCP
		LD		B,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_C_Z[7]
		XON_RBBCP
		LD		C,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_C_Z_[10]
		XON_RBBCP
		LD		C,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_D_Z[7]
		XON_RBBCP
		LD		D,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_D_Z_[10]
		XON_RBBCP
		LD		D,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_E_Z[7]
		XON_RBBCP
		LD		E,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_E_Z_[10]
		XON_RBBCP
		LD		E,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_H_Z[7]
		XON_RBBCP
		LD		H,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_H_Z_[10]
		XON_RBBCP
		LD		H,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_L_Z[7]
		XON_RBBCP
		LD		L,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_L_Z_[10]
		XON_RBBCP
		LD		L,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_AF_Z[10]
		XON_RBBCP
		LD		F,Z+P
		LD		A,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_TMP_Z[10]
		XON_RBBCP
		LD		TMPL,Z+
		LD		TMPH,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_BC_Z[10]
		XON_RBBCP
		LD		C,Z+
		LD		B,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_DE_Z[10]
		XON_RBBCP
		LD		E,Z+
		LD		D,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_HL_Z[10]
		XON_RBBCP
		LD		L,Z+
		LD		H,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_HL_Z_[13]
		XON_RBBCP
		LD		L,Z+
		LD		H,Z
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_PC_Z[11]
		XON_RBBCP
		LD		ZL,X+
		LD		ZH,X+
		XOFF_RBBCP
		MOVW	PCL,ZL
.ENDMACRO

.MACRO LOAD_IX_Z[10]
		XON_RBBCP
		LD		IXL,Z+
		LD		IXH,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IY_Z[10]
		XON_RBBCP
		LD		IYL,Z+
		LD		IYH,Z+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_IY_Z_[15]
		XON_RBBCP
		LD		TMPL,Z+
		LD		TMPH,Z+
		LD		BUF,X
		XOFF_RBBCP
		MOV		IYL,TMPL
		MOV		IYH,TMPH
.ENDMACRO

.MACRO LOAD_STP_PC[10]
		XON_RBBCP
		LD		STPL,X+
		LD		STPH,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_STP_PC_[13]
		XON_RBBCP
		LD		STPL,X+
		LD		STPH,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_STP_Z[10]
		XON_RBBCP
		LD		STPL,Z+
		LD		STPH,Z
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_Z_PC[10]
		XON_RBBCP
		LD		ZL,X+
		LD		ZH,X+
		XOFF_RBBCP
.ENDMACRO

.MACRO LOAD_Z_PC_[13]
		XON_RBBCP
		LD		ZL,X+
		LD		ZH,X+
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO


;***********************************************************************************************
;***********************************************************************************************

.MACRO RLOAD_BUF[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	BUF,Z+
		ADIW	PCL,0X01	
.ENDMACRO

.MACRO RLOAD_RES[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	RES,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_IYH[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	IYH,Z
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_IYL[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	IYL,Z
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_TMPL[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	TMPL,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_TMPL_Z[4]
		OR		ZH,ROMID
		ELPM	TMPL,Z
.ENDMACRO

.MACRO RLOAD_BUF_Z[4]
		OR		ZH,ROMID
		ELPM	BUF,Z
.ENDMACRO

.MACRO RLOAD_RES_Z[4]
		OR		ZH,ROMID
		ELPM	RES,Z
.ENDMACRO

.MACRO RLOAD_BUFH_Z[4]
		OR		ZH,ROMID
		ELPM	BUFH,Z
.ENDMACRO

.MACRO RLOAD_A[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	A,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_A_Z[4]
		OR		ZH,ROMID
		ELPM	A,Z
.ENDMACRO

.MACRO RLOAD_A_ZI[5]
		OR		ZH,ROMID	
		ELPM	A,Z+
		CBR		ZH,0B11000000
.ENDMACRO

.MACRO RLOAD_B[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	B,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_C[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	C,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_D[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	D,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_E[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	E,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_H[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	H,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_L[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	L,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_IXH[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	IXH,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_IXL[7]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	IXL,Z+
		ADIW	PCL,0X01
.ENDMACRO

.MACRO RLOAD_BC[10]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	C,Z+
		ELPM	B,Z+
		ADIW	PCL,0X02
.ENDMACRO

.MACRO RLOAD_DE[10]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	E,Z+
		ELPM	D,Z+
		ADIW	PCL,0X02
.ENDMACRO

.MACRO RLOAD_HL[10]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	L,Z+
		ELPM	H,Z+
		ADIW	PCL,0X02
.ENDMACRO

.MACRO RLOAD_IX[10]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	IXL,Z+
		ELPM	IXH,Z+
		ADIW	PCL,0X02
.ENDMACRO

.MACRO RLOAD_TMP_Z[7]
		OR		ZH,ROMID
		ELPM	TMPL,Z+
		ELPM	TMPH,Z
.ENDMACRO

.MACRO RLOAD_BC_Z[7]
		OR		ZH,ROMID
		ELPM	C,Z+
		ELPM	B,Z
.ENDMACRO

.MACRO RLOAD_DE_Z[7]
		OR		ZH,ROMID
		ELPM	E,Z+
		ELPM	D,Z
.ENDMACRO

.MACRO RLOAD_HL_Z[7]
		OR		ZH,ROMID
		ELPM	L,Z+
		ELPM	H,Z
.ENDMACRO

.MACRO RLOAD_IX_Z[9]
		OR		ZH,ROMID
		ELPM		BUF,Z+
		MOV		IXL,BUF
		ELPM		BUF,Z
		MOV		IXH,BUF
.ENDMACRO

.MACRO RLOAD_IY_Z[9]
		OR		ZH,ROMID	
		ELPM		TMPL,Z+
		MOV		IYL,TMPL
		ELPM		TMPL,Z
		MOV		IYH,TMPL
.ENDMACRO

.MACRO RLOAD_PC[8]
		MOVW	ZL,PCL 
		OR		ZH,ROMID
		ELPM		PCL,Z+
		ELPM		PCH,Z+
.ENDMACRO

.MACRO RLOAD_STP[10]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM		STPL,Z+
		ELPM		STPH,Z+
		ADIW	PCL,0X02	
.ENDMACRO

.MACRO RLOAD_STP_Z[7]
		OR		ZH,ROMID
		ELPM		STPL,Z+
		ELPM		STPH,Z
.ENDMACRO

.MACRO RLOAD_Z_PC[11]
		MOVW	ZL,PCL
		OR		ZH,ROMID
		ELPM	BUFH,Z+
		ELPM	ZH,Z
		ADIW	PCL,0X02
		MOV		ZL,BUFH
.ENDMACRO


;***********************************************************************************************
;***********************************************************************************************


.MACRO SAVE_RES_Z[7]
		XON_RBBCP
		ST		Z,RES
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_RES_Z_[10]
		XON_RBBCP
		ST		Z,RES
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BUF_Z[7]
		XON_RBBCP
		ST		Z,BUF
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BUFH_Z[7]
		XON_RBBCP
		ST		Z,BUFH
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BUFH_Z_[10]
		XON_RBBCP
		ST		Z,BUFH
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BUF_Z_[10]
		XON_RBBCP
		ST		Z,BUF
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_TMP_Z[10]
		XON_RBBCP
		ST		Z+,TMPL
		ST		Z,TMPH
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_TMPH_Z[7]
		XON_RBBCP
		ST		Z,TMPH
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_TMPL_Z[7]
		XON_RBBCP
		ST		Z,TMPL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_TMPL_ZI[7]
		XON_RBBCP
		ST		Z+,TMPL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_A_Z[7]
		XON_RBBCP
		ST		Z,A
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_A_Z_[10]
		XON_RBBCP
		ST		Z,A
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_A_ZI[7]
		XON_RBBCP
		ST		Z+,A
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_A_ZI_[10]
		XON_RBBCP
		ST		Z+,A
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_B_Z[7]
		XON_RBBCP
		ST		Z,B
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_B_Z_[10]
		XON_RBBCP
		ST		Z,B
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_C_Z[7]
		XON_RBBCP
		ST		Z,C
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_C_Z_[10]
		XON_RBBCP
		ST		Z,C
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_D_Z[7]
		XON_RBBCP
		ST		Z,D
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_D_Z_[10]
		XON_RBBCP
		ST		Z,D
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_E_Z[7]
		XON_RBBCP
		ST		Z,E
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_E_Z_[10]
		XON_RBBCP
		ST		Z,E
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_H_Z[7]
		XON_RBBCP
		ST		Z,H
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_H_Z_[10]
		XON_RBBCP
		ST		Z,H
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_L_Z[7]
		XON_RBBCP
		ST		Z,L
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_L_Z_[10]
		XON_RBBCP
		ST		Z,L
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO


.MACRO SAVE_STP_Z[10]
		XON_RBBCP
		ST		Z+,STPL
		ST		Z,STPH
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_AF_Z[10]
		XON_RBBCP
		ST		Z+,F
		ST		Z,A
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BC_Z[10]
		XON_RBBCP
		ST		Z+,C
		ST		Z,B
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BC_Z_[13]
		XON_RBBCP
		ST		Z+,C
		ST		Z,B
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_DE_Z[10]
		XON_RBBCP
		ST		Z+,E
		ST		Z,D
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_DE_Z_[13]
		XON_RBBCP
		ST		Z+,E
		ST		Z,D
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_HL_Z[10]
		XON_RBBCP
		ST		Z+,L
		ST		Z,H
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_HL_Z_[13]
		XON_RBBCP
		ST		Z+,L
		ST		Z,H
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IX_Z[12]
		MOV		TMPL,IXL
		MOV		BUF,IXH
		XON_RBBCP
		ST		Z+,TMPL
		ST		Z,BUF
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IY_Z[12]
		MOV		TMPL,IYL
		MOV		BUF,IYH
		XON_RBBCP
		ST		Z+,TMPL
		ST		Z,BUF
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_PC_SP[10]
		XON_RBBCP
		ST		-Y,PCH
		ST		-Y,PCL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BC_SP[10]
		XON_RBBCP
		ST		-Y,B
		ST		-Y,C
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_BC_SP_[13]
		XON_RBBCP
		ST		-Y,B
		ST		-Y,C
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_DE_SP[10]
		XON_RBBCP
		ST		-Y,D
		ST		-Y,E
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_DE_SP_[13]
		XON_RBBCP
		ST		-Y,D
		ST		-Y,E
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_HL_SP[10]
		XON_RBBCP
		ST		-Y,H
		ST		-Y,L
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_HL_SP_[13]
		XON_RBBCP
		ST		-Y,H
		ST		-Y,L
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_Z_SP[10]
		XON_RBBCP
		ST		-Y,ZH
		ST		-Y,ZL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_Z_SP_[13]
		XON_RBBCP
		ST		-Y,ZH
		ST		-Y,ZL
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IX_STP[10]
		XON_RBBCP
		ST		-Y,IXH
		ST		-Y,IXL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IX_STP_[13]
		XON_RBBCP
		ST		-Y,IXH
		ST		-Y,IXL
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_TMP_SP[10]
		XON_RBBCP
		ST		-Y,TMPH
		ST		-Y,TMPL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IY_SP[10]
		XON_RBBCP
		ST		-Y,IYH
		ST		-Y,IYL
		XOFF_RBBCP
.ENDMACRO

.MACRO SAVE_IY_SP_[13]
		XON_RBBCP
		ST		-Y,IYH
		ST		-Y,IYL
		LD		BUF,X
		XOFF_RBBCP
.ENDMACRO


